#include <stdio.h>


#define LEN     ( sizeof(a) / sizeof(*a) )


const double a[] = {
  1.32, -2.2,  5.45,  6.4, -2.8,  7.84,  7.9, -2.9, -2.9, -3.6
};


int main(void)
{
  double tmp, prev;
  int i, iNonDecreasing;

  /* Check the array is non-decreasing after we replace 
   * all of its negative members with their squares. */
  iNonDecreasing = -1;
  prev = *a < 0 ? *a * *a : *a;
  for ( i = 1; i < LEN; i++ ) {
    tmp = *(a + i) < 0 ? *(a + i) * *(a + i) : *(a + i);

    if ( tmp < prev ) {
      iNonDecreasing = 0;
      break;
    }

    prev = tmp;
  }

  /* Calculate the appropriate result */
  if ( iNonDecreasing )
    for ( i = 0, tmp = 0; i < LEN; i++ )
      tmp += *(a + i);
  else
    for ( i = 0, tmp = 1; i < LEN; i++ )
      tmp *= *(a + i);

  printf("We %sget non-decreasing array; the result is %le\n",
         iNonDecreasing ? "" : "do not ",
         tmp);

  return 0;
}



/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 3_05.c" */
/* End: */
