#include <stdio.h>


/* Linked list element structure */
typedef struct _arr_el {
  int value;
  struct _arr_el *next;
} arr_el;

/* hard-coded elements of the linked list */
arr_el arr[] = {
  { 9},
  { 2},
  { 5},
  { 6},
  {-2},
  { 7},
  {-7},
  {-3},
  {-3},
  {-2}
};

/* this will point to the first element of the list */
arr_el head;


int main(void)
{
  int i, iFoundSome;
  arr_el *curr, *prev, *ptr;

  /*
   * Fill in pointers into singly linked list.  Can actually be
   * replaced by a code which will ask user for the input and create
   * the linked list dynamically
   */
  for ( i = 0; i < sizeof(arr) / sizeof(arr_el) - 1; i++ )
    (arr + i)->next = (arr + i + 1);
  (arr + i)->next = (arr_el *) NULL; /* finish up the list */
  head.next = arr; /* point head to the first element */

  /*
   * The idea:  take first element, see if any other elements with
   * the same value are in the array.  If yes, exclude them all and
   * the first element.  No go to the element after the first, and
   * repeat the procedure.
   */
  prev = &head;
  curr = arr;

  while ( curr && curr->next ) { /* always check curr != NULL! (see
                                  * notes at the end of the loop */
    ptr = curr;
    iFoundSome = 0;

    /* check all consequent elements */
    while ( ptr->next )
      if ( ptr->next->value == curr->value) {
        /* found an element with same value--exclude it */
        iFoundSome = -1;
        ptr->next = ptr->next->next;
      }
      else
        /* skip to next element */
        ptr = ptr->next;

    if ( iFoundSome )
      /* repeating elements were found and excluded, exclude this one
       * also */
      prev->next = curr->next;
    else
      prev = curr;

    curr = curr->next; /* This can zero out curr (in cases when last
                        * two elements are the same and do not occur
                        * before)--hence check curr != NULL in the
                        * outer while loop */
  }

  if ( !head.next )
    fputs("No non-repeating elements found!\n", stdout);
  else {
    fputs("Elements repeating only once:\n", stdout);
    ptr = &head;
    while ( ptr->next ) {
      ptr = ptr->next;
      printf("%6d\n", ptr->value);
    }
  }

  return 0;
}



/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 3_16.c" */
/* End: */
