#include <stdio.h>


#define ROWS        (sizeof(arr) / sizeof(arr[0]))
#define COLS        9


double arr[][COLS] = {
  {  1.3,  6.2, -2.6, -7.3, -8.6, -4.0,  4.7, -3.6,  7.7},
  {  1.5,  5.5, -8.6,  2.4, -4.4,  7.0, -7.3,  2.5, -3.3},
  { -3.6,  2.7, -4.5, -5.3,  7.9,  3.5,  4.8,  4.6,  2.8},
  {  1.3, -5.1,  2.3, -8.6, -2.7,  4.0, -2.6,  3.8, -9.0},
  { -5.1,  2.2, -2.6,  7.8,  3.0, -8.9,  6.7, -8.3,  3.2},
  {  2.4,  8.4,  7.3,  9.3, -8.4,  5.4,  4.1, -9.0,  2.2},
};


void print_out(double arr[][COLS], int, int);


int main(void)
{
  int    i, j, row_min, row_max;
  double min, max, tmp;

  print_out(arr, ROWS, COLS);
  putchar('\n');

  /*
   * Find max and min elements
   */
  min = max = **arr;
  row_min = row_max = 0;

  for ( i = 0; i < ROWS; i++ )
    for ( j = 0; j < COLS; j++) {
      tmp = *( *(arr + i) + j);
      if ( tmp < min )
        min = tmp, row_min = i;
      else if ( tmp > max )
        max = tmp, row_max = i;
    }

  /*
   * Swap the lines
   */
  if ( row_min != row_max )
    for ( j = 0; j < COLS; j++) {
      tmp = *(*(arr + row_min) + j);
      *(*(arr + row_min) + j) = *(*(arr + row_max) + j);
      *(*(arr + row_max) + j) = tmp;
    }

  printf("row_min=%d, min=%le\nrow_max=%d, max=%le\n\n", row_min, min, row_max, max);
  print_out(arr, ROWS, COLS);

  return 0;
}


void print_out(double arr[][COLS], int rows, int cols)
{
  int i, j;

  for ( i = 0; i < rows; i++ ) {
    for ( j = 0; j < cols; j++ )
      printf("%8.1le ", *(*(arr + i) + j));
    putchar('\n');
  }

  return;
}




/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 4_05.c" */
/* End: */
