#include <stdio.h>
#include <stdlib.h>


#define __DEBUG__


#ifdef __DEBUG__
#define N           5
double arr[N*N] = {
   1.3,  6.2, -2.6, -7.3, -8.6,
   1.5,  5.5, -8.6,  2.4, -4.4,
  -3.6,  2.7, -4.5, -5.3,  7.9,
   1.3, -5.1,  2.3, -8.9, -2.7,
  -5.1,  2.2, -2.6,  7.8,  3.0
};
#else
double *arr;
#endif /* __DEBUG__ */


int main(void)
{
  int    n, i, j, row_min;
  double tmp;

#ifdef __DEBUG__
  n = N;
#else
  fputs("Enter n:  ", stdout);
  scanf("%d", &n);
  arr = (double *) malloc(n * n * sizeof(double));
  if ( !arr ) {
    fputs("Not enough memory!\n", stderr);
    return -1;
  }
  for ( i = 0; i < n; i++ )
    for ( j = 0; j < n; j++) {
      printf("[%02d,%02d]:", i, j);
      scanf("%le", arr + i * n + j);
    }
#endif /* __DEBUG__ */

  /*
   * Find min element
   */
  tmp = *arr;
  row_min = 0;
  j = n * n;

  for ( i = 0; i < j; i++ )
    if ( *(arr + i) < tmp )
      tmp = *(arr + i), row_min = i / n;

  printf("row_min=%d, min=%le, ", row_min, tmp);

  /*
   * Calc the sum
   */
  j = n * row_min + n;
  tmp = 0;
  for ( i = n * row_min; i < j; i++)
    tmp += *(arr + i);

  printf("sum=%le\n", tmp);

#ifndef __DEBUG__
  /* Free the mallocs! */
  free(arr);
#endif /* __DEBUG__ */

  return 0;
}




/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 4_16.c" */
/* End: */
