#include <stdio.h>
#include <stdlib.h>


#define MEM_ALLOC_UNIT      256


const char *strErrorMem = "Not enough memory!\n";


const char strReplacee[] = "child";
const char strReplacement[] = "children";

const char strOrig[] =
"Yeah I'm a voodoo child
Lord I'm a voodoo child";

char *strRes;


int main(void)
{
  char *ptr, *prev, c;
  int i, j;
  int iReplaceeLen, iReplacementLen, iOrigLen, iResLen;

  iReplaceeLen = sizeof(strReplacee) - 1;
  iReplacementLen = sizeof(strReplacement) - 1;
  iOrigLen = sizeof(strOrig) - 1;
  iResLen = iOrigLen;

  strRes = (char *) malloc(iOrigLen + 1);
  if ( !strRes ) {
    fputs(strErrorMem, stderr);
    return -1;
  }
  memcpy(strRes, strOrig, iOrigLen + 1);

  i = 0;
  prev = (char *) strOrig;
  ptr = (char *) strstr(strOrig, strReplacee);

  while (ptr) { /* loop while we find any occurences of strReplacee */
    /* See that we either at the beginning of strOrig, or that we
       have delimiter before the token */
    if ( ptr > strOrig )
      c = *(ptr - 1);
    if ( ptr == strOrig || ispunct(c) || isspace(c) ) {
      /* See that we are at the end of strOrig, or that we have
         delimiter after the token */
      c = *(ptr + iReplaceeLen);
      if ( c == '\0' || ispunct(c) || isspace(c) ) {
        /* see if we have enough buffer left ( `>=' takes provision
           for the terminating '\0' ) */
        while ( i + ptr - prev + iReplacementLen >= iResLen ) {
          iResLen += MEM_ALLOC_UNIT;
          strRes = realloc(strRes, iResLen);
          if ( !strRes ) {
            fputs(strErrorMem, stderr);
            return -1;
          }
        }
        /* copy strOrig from where we left off erlier up to ptr */
        while ( prev != ptr )
          *(strRes + i++) = *prev++;
        /* copy the replacement */
        j = 0;
        while ( j < iReplacementLen )
          *(strRes + i++) = *(strReplacement + j++);
        prev = ptr + iReplaceeLen;
      }
    }
    ptr++; /* `ptr += iReplaceeLen;' won't do--may miss another token
            * which starts inside the one we found, though this is
            * possible only if iReplacee is more than one word */

    /* search next occurence of strReplacement in strOrig */
    ptr = (char *) strstr(ptr, strReplacee);
  }

  /* copy the remaining part of strOrig */
  ptr = (char *) strOrig + iOrigLen;
  while ( prev <= ptr ) /* include the terminating '\0' */
    *(strRes + i++) = *prev++;

  printf("\n***Original string:\n\n%s\n\n***Resulting string:\n\n%s\n\n",
         strOrig,
         strRes);

  /* Free the mallocs! */
  free(strRes);

  return 0;
}




/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 5_05.c" */
/* End: */
