#include <stdio.h>


const char *strSrcFname = "6_05.src";
const char *strTmpFname = "6_05.tmp";
const char *strDstFname = "6_05.dst";


const char *strErrorFileOpen = "Error opening file `%s'\n";


int main(void)
{
  FILE *fSrc, *fTmp, *fDst;
  int i, j, iDone;

  /* Open the files */
  if ( !( fSrc = fopen(strSrcFname, "r") ) ) {
    printf(strErrorFileOpen, strSrcFname);
    return -1;
  }
  if ( !( fTmp = fopen(strTmpFname, "w+") ) ) {
    printf(strErrorFileOpen, strTmpFname);
    return -1;
  }
  if ( !( fDst = fopen(strDstFname, "w") ) ) {
    printf(strErrorFileOpen, strDstFname);
    return -1;
  }

  /* Write all non-negative numbers into fTmp file */
  while ( fscanf(fSrc, "%d", &i) != EOF ) {
    if ( i >= 0 )
      fprintf(fTmp, "%d ", i);
  }

  /* Reset file pointers */
  fseek(fSrc, 0, SEEK_SET);
  fseek(fTmp, 0, SEEK_SET);

  iDone = 0;

  while ( !iDone ) {

    /* Write two non-negative characters */
    if ( iDone = ( fscanf(fTmp, "%d\n%d", &i, &j) == EOF ) ? -1 : 0 )
      break;
    fprintf(fDst, "%6d %6d ", i, j);

    /* Find and write two negative characters */
    for ( j = 0; j < 2 && !iDone; j++ ) {
      do {
        iDone = ( fscanf(fSrc, "%d", &i) == EOF ) ? -1 : 0;
      } while ( i >= 0 && !iDone );
      fprintf(fDst, "%6d ", i);
    }
  }

  fclose(fDst);
  fclose(fTmp);
  fclose(fSrc);

  return 0;
}




/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 6_05.c" */
/* End: */
