#include <stdio.h>


const char *strSrcFname = "6_16.src";
const char *strDstFname = "6_16.dst";


const char *strErrorFileOpen = "Error opening file `%s'\n";
const char *strErrorFileFormat = "File `%s':  wrong file format!\n";

int pos[10];
int neg[10];


int main(void)
{
  FILE *fSrc, *fDst;
  int i, j, iDone;
  int *ptrPos, *ptrNeg;

  /* Open the files */
  if ( !( fSrc = fopen(strSrcFname, "r") ) ) {
    printf(strErrorFileOpen, strSrcFname);
    return -1;
  }
  if ( !( fDst = fopen(strDstFname, "w") ) ) {
    printf(strErrorFileOpen, strDstFname);
    return -1;
  }

  iDone = 0;
  while ( !iDone ) {
    /* Read ten positive numbers */
    for ( i = 0; i < 10; i++ )
      if ( fscanf(fSrc, "%d", pos + i) == EOF )
        break;
    if ( i == 0 ) {
      iDone = -1;
      break;
    }
    if ( i < 10 ) {
      fprintf(stderr, strErrorFileFormat, strSrcFname);
      return -1;
    }

    /* Read ten negative numbers */
    for ( i = 0; i < 10; i++ )
      if ( fscanf(fSrc, "%d", neg + i) == EOF )
        break;
    if ( i < 10 ) {
      fprintf(stderr, strErrorFileFormat, strSrcFname);
      return -1;
    }

    /* Write five positive, five negative, five postitive, five
       negative */
    ptrPos = pos;
    ptrNeg = neg;
    for ( i = 0; i < 2; i++ ) {
      /* Write five positive numbers */
      for ( j = 0; j < 5; j++ )
        fprintf(fDst, "%8d ", *ptrPos++);
      /* Write five negative numbers */
      for ( j = 0; j < 5; j++ )
        fprintf(fDst, "%8d ", *ptrNeg++);
    }
  }

  fclose(fDst);
  fclose(fSrc);

  return 0;
}




/*********** Emacs vars ***********/
/* Local variables: */
/* compile-command: "gcc 6_16.c" */
/* End: */
